Monster = Object:extend()

function Monster:new(grid_x, grid_y, health, damage)
    self.grid_x = grid_x
    self.grid_y = grid_y
    self.act_x = grid_x
    self.act_y = grid_y
    self.speed = 10
	self.maxhealth = health
	self.health = health
	self.damage = damage
	self.trapdamage = 30
end

function Monster:update(dt)
    if self.health < 0 then
		self.health = 0
	end
	if self.health > self.maxhealth then
		self.health = self.maxhealth
	end
	if player.movetimer == 10 and self.health > 0 then
		if player.grid_x > self.grid_x and self.TestMap(1, 0) then
			if self.TestTrap(1, 0) then
				self.health = self.health - self.trapdamage
				map[(self.grid_y / 32 + 1)][(self.grid_x / 32)] = 0
			end
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 0
			self.grid_x = self.grid_x + 32
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 2
		elseif player.grid_x < self.grid_x and self.TestMap(-1, 0) then
			if self.TestTrap(-1, 0) then
				self.health = self.health - self.trapdamage
				map[(self.grid_y / 32 - 1)][(self.grid_x / 32)] = 0
			end
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 0
			self.grid_x = self.grid_x - 32
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 2
		elseif player.grid_y > self.grid_y and self.TestMap(0, 1) then
			if self.TestTrap(0, 1) then
				self.health = self.health - self.trapdamage
				map[(self.grid_y / 32)][(self.grid_x / 32 + 1)] = 0
			end
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 0
			self.grid_y = self.grid_y + 32
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 2
		elseif player.grid_y < self.grid_y and self.TestMap(0, -1) then
			if self.TestTrap(0, -1) then
				self.health = self.health - self.trapdamage
				map[(self.grid_y / 32)][(self.grid_x / 32 - 1)] = 0
			end
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 0
			self.grid_y = self.grid_y - 32
			emap[(self.grid_y / 32)][(self.grid_x / 32)] = 2
		else
			if self.TestPlayer(1, 0) then
				player.health = player.health - self.damage
			end
			if self.TestPlayer(-1, 0) then
				player.health = player.health - self.damage
			end
			if self.TestPlayer(0, 1) then
				player.health = player.health - self.damage
			end
			if self.TestPlayer(0, -1) then
				player.health = player.health - self.damage
			end
		end
	end
	self.act_y = self.act_y - ((self.act_y - self.grid_y) * self.speed * dt)
	self.act_x = self.act_x - ((self.act_x - self.grid_x) * self.speed * dt)
end

function Monster:draw()
    love.graphics.setColor(255, 0, 0)
	love.graphics.rectangle("fill", self.act_x, self.act_y, 32, 32)
	if self.health > 0 then
		love.graphics.setColor(255, 200, 0)
	end
	if self.health < 1 then
		love.graphics.setColor(0, 0, 0)
	end
	love.graphics.rectangle("fill", self.act_x + 4, self.act_y + 8, 8, 4)
	love.graphics.rectangle("fill", self.act_x + 20, self.act_y + 8, 8, 4)
end

function Monster:TestMap(x, y)
	if clone.map[self:grid_x / 32 + x][self:grid_y / 32 + y] == 1 then
		return false
	end
	if clone.emap[self:grid_x / 32 + x][self:grid_y / 32 + y] == 2 then
		return false
	end
	if clone.emap[self:grid_x / 32 + x][self:grid_y / 32 + y] == 3 then
		return false
	end
	if clone.map[self:grid_x / 32 + x][self:grid_y / 32 + y] == 5 then
		return false
	end
	return true
end
function Monster:TestPlayer(x, y)
	if emap[self.grid_x / 32 + x][self.grid_y / 32 + y] == 3 then
		return true
	end
	return false
end
function Monster:TestTrap(x, y)
	if emap[self.grid_x / 32 + x][self.grid_y / 32 + y] == 4 then
		return true
	end
	return false
end